﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace pzmni
{
    public class Rectangle
    {
        public int X { get; set; }
        public int Y { get; set; }
        public string Name { get; set; }

        public Rectangle(int x=0, int y=0, string name="default name")
        {
            this.X = x;
            this.Y = y;
            this.Name = name;
        }

        public override bool Equals(object obj)
        {
            if (!(obj is Rectangle))
                return false;
            Rectangle other = (Rectangle)obj;

            if (X == other.X && X == other.Y && Name == other.Name)
                return true;
            if (X == other.Y && Y == other.X && Name == other.Name)
                return true;
            return false;
        }
        public override int GetHashCode()
        {
            return X ^ Y;
        }
        public override string ToString()
        {
            return String.Format("{0}x{1} ({2})", X, Y, Name);
        }

        public Rectangle Rotated
        {
            get
            {
                return new Rectangle(this.Y, this.X, this.Name);
            }
        }
        


    }
}
